package ru.ifmo.hmm;

public class Test {
    public static void main(String[] args) {
        Hmm hmm = new Hmm(18, 3);

//        int[][] ss = {{1, 0, 1, 0, 1, 0, 1}};
//        int[][] ss = {{0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1,}};
        int[][] ss = {{0, 1, 2}};

        double p1 = hmm.solve1(ss);
        hmm.estimate(ss, 1e-10);
        double p2 = hmm.solve1(ss);
        hmm.solve3(ss, 1e-10);
        double p3 = hmm.solve1(ss);
        System.out.println(p1 + " -> " + p2 + " -> " + p3);
        print(hmm);
    }

    private static void print(Hmm hmm) {
        System.out.println("A");
        for (int i = 0; i < hmm.a.length; i++) {
            for (int j = 0; j < hmm.a.length; j++) {
                System.out.printf("%.2f ", hmm.a[i][j]);
            }
            System.out.println("");
        }
        System.out.println("");
        System.out.println("B");
        for (int i = 0; i < hmm.b.length; i++) {
            for (int j = 0; j < hmm.b[0].length; j++) {
                System.out.printf("%.2f ", hmm.b[i][j]);
            }
            System.out.println("");
        }
        System.out.println("");
        System.out.println("P");
        for (int i = 0; i < hmm.h.length; i++) {
            System.out.printf("%.2f ", hmm.h[i]);
        }
        System.out.println("");
    }

}
